define(["jquery","TYPO3/CMS/Gridexample/grideditor/react","TYPO3/CMS/Gridexample/grideditor/react-dom","TYPO3/CMS/Gridexample/grideditor/polished","TYPO3/CMS/Gridexample/grideditor/styled-components","TYPO3/CMS/Gridexample/grideditor/GridTemplateParser"],function(t,e,r,n,i,o){"use strict";var s=function(t){this.initialize(t)};return s.prototype={identifier:"grid",field:"",selectorEditor:"#grideditor-grid",areaCount:1,rowCount:1,colCount:1,areas:{},supportsES6:function(){try{return new Function("(a = 0) => a"),!0}catch(t){return!1}},build:function(){function t(t,e,r){return e in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t}const{render:s}=r,{Component:a}=e,{div:d,svg:h,line:l,text:u}=i.default,{darken:c,transparentize:g}=n,{grid:p,template:m}=o,f=(t,e,r)=>Math.min(Math.max(t,e),r),w="#f9f9f9",v="#0000ff",y=d`
          display: grid;
          grid-template-columns: auto;
          grid-template-rows: auto;
          grid-template-areas: "main";
          width: 100%;
        `,E=d`
          display: flex;
          flex-direction: column;
          grid-area: main;
          padding: 2rem;
          background: ${w};
        `,b=d`
          flex: 1;
          position: relative;
        `,A=h`
          position: absolute;
          top: 0;
          right: 0;
          bottom: 0;
          left: 0;
          width: 100%;
          height: 100%;
          padding: 0;
        `,M=u`
          font-size: 1rem;
          text-anchor: middle;
          alignment-baseline: middle;
          fill: ${v};
        `,k=l`
          stroke: ${c(.1,w)};
          stroke-width: 1px;
          stroke-dasharray: 8 6;
        `,C=d`
          z-index: 5;
          padding: 0;
          position: relative;
          display: grid;
          grid-template-columns: repeat(${t=>t.width}, 1fr);
          grid-template-rows: repeat(${t=>t.height}, 1fr);
          grid-template-areas: ${t=>t.tpl};
          width: 100%;
          height: 100%;
        `,x=d`
          min-height: 60px;
          margin: 6px;
          position: relative;
          grid-area: ${t=>t.area};
          cursor: ${t=>t.grabbing?"grabbing":"grab"};
          background: ${g(.95,v)};
        `,D=d`
          position: absolute;
          top: ${({position:t})=>"bottom"===t?"auto":0};
          right: ${({position:t})=>"left"===t?"auto":0};
          bottom: ${({position:t})=>"top"===t?"auto":0};
          left: ${({position:t})=>"right"===t?"auto":0};
          width: ${({position:t,size:e})=>"left"===t||"right"===t?e:"100%"};
          height: ${({position:t,size:e})=>"top"===t||"bottom"===t?e:"100%"};
          cursor: ${({position:t})=>"left"===t||"right"===t?"col-resize":"row-resize"};
          background: ${v};
        `;d`
          flex: 1;
          display: flex;
          flex-direction: column;
          padding: 1rem;
        `,d`
          flex: 1;
        `;function $({tpl:t,width:r,height:n,areas:i,setArea:o,setWidth:s,setHeight:a}){return e.createElement(E,null,e.createElement(b,null,e.createElement(F,{width:r,height:n,areas:i}),e.createElement(j,{tpl:t,width:r,height:n,areas:i,setArea:o})))}function S({area:t,column:r,row:n,grabbing:i,onMouseDown:o,onHandlerMouseDown:s}){return e.createElement(x,{area:t,grabbing:i,onMouseDown:o},e.createElement(T,{position:"right",onMouseDown:s("right")}),e.createElement(T,{position:"left",onMouseDown:s("left")}),e.createElement(T,{position:"top",onMouseDown:s("top")}),e.createElement(T,{position:"bottom",onMouseDown:s("bottom")}))}function T({position:t,onMouseDown:r}){return e.createElement(D,{size:"3px",position:t,onMouseDown:r})}class P extends a{constructor(...e){super(...e),t(this,"state",{isFocused:!1,value:this.props.value}),t(this,"handleFocus",t=>{t.persist(),this.props.onFocus(t),this.setState(()=>({isFocused:!0}))}),t(this,"handleBlur",t=>{t.persist(),this.props.onBlur(t),this.setState(()=>({isFocused:!1}))}),t(this,"handleChange",t=>{t.persist();const{value:e}=t.target;this.props.onChange(t),this.setState(()=>({value:e}))})}componentWillReceiveProps({value:t}){this.setState(()=>({value:t}))}render(){const{isFocused:t}=this.state,e=t?this.state.value:this.props.value;return this.props.children({value:e,onFocus:this.handleFocus,onBlur:this.handleBlur,onChange:this.handleChange})}}t(P,"defaultProps",{value:"",onFocus:()=>{},onBlur:()=>{},onChange:()=>{}});class j extends a{constructor(){super(),t(this,"state",{isDragging:!1,draggedArea:null,draggedPosition:null}),t(this,"handleMouseUp",t=>{this.state.isDragging&&this.setState(()=>({isDragging:!1,draggedArea:null,draggedPosition:null}))}),t(this,"handleMouseMove",t=>{const{width:e,height:r}=this.props,{isDragging:n,draggedArea:i,draggedPosition:o}=this.state;if(n){const n=this.node.getBoundingClientRect(),s=Math.round((t.clientX-n.left)/n.width*e),a=Math.round((t.clientY-n.top)/n.height*r);switch(!0){case"string"==typeof o:return this.moveHandler(s,a);case"string"==typeof i:return this.moveTrack(s,a)}}}),t(this,"makeTrackMouseDown",t=>e=>{e.preventDefault();const{width:r,height:n,areas:i}=this.props,o=i[t],s=this.node.getBoundingClientRect(),a=Math.round((e.clientX-s.left)/s.width*r),d=Math.round((e.clientY-s.top)/s.height*n);this.dx=a-o.column.start+1,this.dy=d-o.row.start+1,this.setState(()=>({isDragging:!0,draggedArea:t}))}),t(this,"makeHandlerMouseDown",t=>e=>r=>{r.preventDefault(),this.setState(()=>({isDragging:!0,draggedArea:t,draggedPosition:e}))}),t(this,"moveTrack",(t,e)=>{const{width:r,height:n,areas:i,setArea:o}=this.props,{draggedArea:s}=this.state,a=i[s],d=this.findAdjacentArea("top",s),h=this.findAdjacentArea("right",s),l=this.findAdjacentArea("bottom",s),u=this.findAdjacentArea("left",s),c=f(t-this.dx+1,"string"==typeof u?i[u].column.end:1,("string"==typeof h?i[h].column.start:r+1)-a.column.span),g=f(e-this.dy+1,"string"==typeof d?i[d].row.end:1,("string"==typeof l?i[l].row.start:n+1)-a.row.span);if(c!==a.column.start||g!==a.row.start){const t=c+a.column.span,e=g+a.row.span;return o(s,{column:{...a.column,start:c,end:t},row:{...a.row,start:g,end:e}})}}),t(this,"moveHandler",(t,e)=>{const{width:r,height:n,areas:i,setArea:o}=this.props,{draggedPosition:s,draggedArea:a}=this.state,d=i[a],h=this.findAdjacentArea(s,a);if("top"===s){const t=f(e+1,"string"==typeof h?i[h].row.end:1,d.row.end-1);return o(a,{...d,row:{...d.row,span:d.row.end-t,start:t}})}if("right"===s){const e=f(t+1,d.column.start+1,"string"==typeof h?i[h].column.start:r+1);return o(a,{...d,column:{...d.column,span:e-d.column.start,end:e}})}if("bottom"===s){const t=f(e+1,d.row.start+1,"string"==typeof h?i[h].row.start:n+1);return o(a,{...d,row:{...d.row,span:t-d.row.start,end:t}})}if("left"===s){const e=f(t+1,"string"==typeof h?i[h].column.end:1,d.column.end-1);return o(a,{...d,column:{...d.column,span:d.column.end-e,start:e}})}}),t(this,"findAdjacentArea",(t,e)=>{const{areas:r}=this.props,{column:n,row:i}=r[e],o=Object.keys(r);return"top"===t?o.find(t=>r[t].row.end===i.start&&r[t].column.start<n.end&&r[t].column.end>n.start):"right"===t?o.find(t=>r[t].column.start===n.end&&r[t].row.start<i.end&&r[t].row.end>i.start):"bottom"===t?o.find(t=>r[t].row.start===i.end&&r[t].column.start<n.end&&r[t].column.end>n.start):"left"===t?o.find(t=>r[t].column.end===n.start&&r[t].row.start<i.end&&r[t].row.end>i.start):void 0}),this.dx=0,this.dy=0}componentDidMount(){document.addEventListener("mouseup",this.handleMouseUp),document.addEventListener("mousemove",this.handleMouseMove)}componentWillUnmount(){document.removeEventListener("mouseup",this.handleMouseUp),document.removeEventListener("mousemove",this.handleMouseMove)}render(){const{tpl:t,width:r,height:n,areas:i}=this.props,{isDragging:o,draggedArea:s,draggedPosition:a}=this.state;return e.createElement(C,{innerRef:t=>this.node=t,tpl:t,width:r,height:n},Object.keys(i).map(t=>e.createElement(S,{key:t,area:t,column:i[t].column,row:i[t].row,grabbing:o&&s===t&&"string"!=typeof a,onMouseDown:this.makeTrackMouseDown(t),onHandlerMouseDown:this.makeHandlerMouseDown(t)})))}}class F extends a{constructor(...r){super(...r),t(this,"renderArea",t=>{const{width:r,height:n,areas:i}=this.props,{row:o,column:s}=i[t];return Array.from({length:o.span},(i,a)=>Array.from({length:s.span},(i,d)=>e.createElement(M,{key:`area${a}${d}`,x:`${(s.start+d-.5)/r*100}%`,y:`${(o.start+a-.5)/n*100}%`},t)))}),t(this,"renderCols",(t,r)=>{const{width:n}=this.props;return e.createElement(k,{key:r,x1:`${(r+1)/n*100}%`,y1:"0%",x2:`${(r+1)/n*100}%`,y2:"100%"})}),t(this,"renderRows",(t,r)=>{const{height:n}=this.props;return e.createElement(k,{key:r,x1:"0%",y1:`${(r+1)/n*100}%`,x2:"100%",y2:`${(r+1)/n*100}%`})})}render(){const{width:t,height:r,areas:n}=this.props;return e.createElement(A,null,e.createElement("g",null,Object.keys(n).map(this.renderArea)),e.createElement("g",null,Array.from({length:t-1},this.renderCols)),e.createElement("g",null,Array.from({length:r-1},this.renderRows)))}}s(e.createElement(class extends a{constructor(...e){super(...e),t(this,"state",{tracks:{width:e[0].GridEditor.colCount,height:e[0].GridEditor.rowCount,areas:e[0].GridEditor.areas}}),t(this,"setTracks",t=>{this.setState(()=>({tracks:p(t.target.value)}))}),t(this,"integer",(t,e,r,n)=>{const i=parseInt(t);return isNaN(i)?e:f(i,r,n)}),t(this,"setWidth",t=>{this.setState(({tracks:e})=>({tracks:{...e,width:this.integer(t.target.value,e.width,1,100)}}))}),t(this,"setHeight",t=>{this.setState(({tracks:e})=>({tracks:{...e,height:this.integer(t.target.value,e.height,1,100)}}))}),t(this,"setArea",(t,r)=>{e[0].GridEditor.setArea(t,r),e[0].GridEditor.writeConfig(e[0].GridEditor.export2LayoutRecord()),this.setState(({tracks:e})=>({tracks:{...e,areas:{...e.areas,[t]:r}}}))})}render(){const{tracks:t}=this.state,{width:r,height:n,areas:i}=t,o=m(t);return e.createElement(y,null,e.createElement($,{tpl:o,width:r,height:n,areas:i,setArea:this.setArea,setWidth:this.setWidth,setHeight:this.setHeight}))}},{GridEditor:this}),document.querySelector(this.selectorEditor))},buildNoES6:function(t){t.append("<p>Internet Explorer do not support ES6, therefor the Grid Editor is not available here! Only default grids are possible. Use a modern browser like Chrome or Firefox!</p>")},initialize:function(e){this.identifier=e,this.selectorEditor="#grideditor-"+this.identifier;var r=t(this.selectorEditor);this.areaCount=r.data("areacount"),this.colCount=r.data("colcount"),this.rowCount=r.data("rowcount"),this.areas=r.data("areas"),this.field=t('input[name="'+r.data("field")+'"]'),this.supportsES6()?this.build():this.buildNoES6(r),this.writeConfig(this.export2LayoutRecord())},writeConfig:function(t){this.field.val(t)},export2LayoutRecord:function(){var e="grid {\n\tcolCount = "+this.colCount+"\n\trowCount = "+this.rowCount+"\n\tareaCount = "+this.areaCount+"\n\tareas {\n";return t.each(this.areas,function(t,r){e+="\t\t"+t+" {\n",e+="\t\t\tcolumn {\n",e+="\t\t\t\tstart = "+r.column.start+"\n",e+="\t\t\t\tend = "+r.column.end+"\n",e+="\t\t\t\tspan = "+r.column.span+"\n",e+="\t\t\t}\n",e+="\t\t\trow {\n",e+="\t\t\t\tstart = "+r.row.start+"\n",e+="\t\t\t\tend = "+r.row.end+"\n",e+="\t\t\t\tspan = "+r.row.span+"\n",e+="\t\t\t}\n",e+="\t\t}\n"}),e+="\t}\n}\n"},setAreas:function(t){this.areas=t},setArea:function(t,e){this.areas[t]=e}},s});
